<?php

/**
  Plugin Name: ZWP Czat
  Version: 1.3
  Description: ZaawansowanyWordpress Czat - prosty czat z edytowalnymi wypowiedziami
  Author: Daniel Kuczewski
  Author URI: http://zaawansowanywordpress.pl
  Plugin URI: http://zaawansowanywordpress.pl/8-shortcode/
 */
require_once 'inc/ZWP_czat.php';

$ZWP_Czat = new ZWP_Czat();

add_action('widgets_init', 'zwpc_register_widget');

function zwpc_register_widget() {
    register_widget('ZWPC_Widget');
}

class ZWPC_Widget extends WP_Widget {

    function ZWPC_Widget() {
        // tablica opcji.
        $widget_ops = array(
            'classname' => 'ZWPC_Widget', //nazwa klasy widgetu
            'description' => 'ZWP Czat', //opis widoczny w panelu
        );
        //ładowanie
        parent::__construct('ZWPC_Widget', 'ZWP Czat', $widget_ops);
    }

    function form($instance) {
        ?>
        <p>
            Widget wyświetla czat.
        </p>
        <?php
    }

    function update($new_instance, $old_instance) {
        return $old_instance;
    }

    function widget($args, $instance) {
        global $ZWP_Czat;
        echo $args['before_widget'];
        $ZWP_Czat->show_zwpc_html('widget');
        echo $args['after_widget'];
    }

}

register_activation_hook(__FILE__, 'zwpc_activation');

function zwpc_activation() {
    global $wpdb;
    $table_name = $wpdb->prefix . 'zwpc_posts';

    if ($wpdb->get_var("SHOW TABLES LIKE '" . $table_name . "'") != $table_name) {
        $query = "CREATE TABLE " . $table_name . " (
        id int(9) NOT NULL AUTO_INCREMENT,
        user_id MEDIUMINT(6) NOT NULL,
        post_content TEXT NOT NULL,
        create_date TIMESTAMP NOT NULL,
        PRIMARY KEY  (id)
        )";

        $wpdb->query($query);
    }

    if (get_page_by_title("ZWP Czat") == null) {
        //Nie ma takiej strony a więc dodaję
        $postarr = [
            "post_title" => "ZWP Czat",
            "post_content" => "Opis czatu",
            "post_type" => "page",
            "post_status" => "publish"
        ];
        wp_insert_post($postarr);
    }
}

define("ZWPC_PATH", plugin_dir_path(__FILE__));
add_filter('page_template', 'zwpc_change_chat_template');

function zwpc_change_chat_template($template) {
    global $post;
    $single_template = ZWPC_PATH . '/templates/zwp_czat.php';
    if (isset($post->post_name) && $post->post_name == 'zwp-czat') {
        return $single_template;
    } else {
        return $template;
    }
}

function zwpc_add_scripts_and_styles() {
    wp_enqueue_style('zwpc-main-css', plugins_url('zwp_czat/css/main.css'));
    wp_enqueue_script( 'zwpc-script-main', plugins_url('zwp_czat/js/main.js') , array(), '1.0.0', true );
    $protocol = isset($_SERVER['HTTPS']) ? 'https://' : 'http://';
    wp_localize_script( 'zwpc-script-main', 'zwp_data', array('ajax_url' => admin_url('admin-ajax.php', $protocol)) );
}

add_action('wp_enqueue_scripts', 'zwpc_add_scripts_and_styles');

function zwpc_shortcode($atr){
    $defaults = array("posts_count" => 100);
    $options = shortcode_atts($defaults, $atr);
    global $ZWP_Czat;
    $ZWP_Czat->show_zwpc_html('shortcode',$options['posts_count']);
}
add_shortcode("zwp_czat", "zwpc_shortcode");

add_action('wp_ajax_nopriv_zwp_get_posts','zwp_ajax_get_posts');
add_action('wp_ajax_zwp_get_posts','zwp_ajax_get_posts');

function zwp_ajax_get_posts(){
    $last_id = empty($_POST['last_id']) ? 0 : (int)$_POST['last_id'];
    global  $ZWP_Czat;
    $res = $ZWP_Czat->get_zwpc_last_posts($last_id);
    echo json_encode($res);
    die();
}

add_action('wp_ajax_nopriv_zwp_add_post','zwp_ajax_add_post');
add_action('wp_ajax_zwp_add_post','zwp_ajax_add_post');

function zwp_ajax_add_post(){
    $post_content = empty($_POST['post_content']) ? 0 : strip_tags($_POST['post_content']);
    if(!empty($post_content)){
        global  $ZWP_Czat;
        $res = $ZWP_Czat->add_post($post_content);
        echo (int)$res;
    } else {
        echo '0';
    }
    die();
}